"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultScrollWidth = exports.CustomScroll = void 0;
var react_1 = __importStar(require("react"));
var events_1 = require("./utils/events");
var getScrollWidth_1 = require("./utils/getScrollWidth");
var clearSelection_1 = require("./utils/clearSelection");
var styles_1 = require("./styles");
var scrollTo_1 = require("./modules/scrollTo");
var mouse_without_window_1 = require("./modules/mouse.without.window");
var generateStyle_1 = require("./utils/generateStyle");
var generateID_1 = require("./utils/generateID");
var is_1 = require("./utils/is");
mouse_without_window_1.mouseWithoutWindow();
/**
 * This is min height for Scroll Bar.
 * If children content will be very big
 * Scroll Bar stay 20 pixels
 * */
var minHeightScrollBar = 20;
var defaultScrollWidth = 17;
var REINIT_MS = 250;
var SCROLL_WIDTH = getScrollWidth_1.getScrollWidth();
// If this is Safari / iPhone / iPad or other browser / device with scrollWidth === 0
var isZero = SCROLL_WIDTH === 0;
var getDefaultScrollWidth = function () { return (typeof SCROLL_WIDTH === 'number' ?
    SCROLL_WIDTH :
    0); };
exports.getDefaultScrollWidth = getDefaultScrollWidth;
var CustomScroll = /** @class */ (function (_super) {
    __extends(CustomScroll, _super);
    function CustomScroll(props) {
        var _this = _super.call(this, props) || this;
        _this.nextWrapperHeight = 0;
        _this.nextHolderHeight = 0;
        _this.scrollID = generateID_1.generateID();
        _this.onClick = function (evt) {
            evt.stopPropagation();
            evt.preventDefault();
            /**
             * If we clicked right mouse button we must skip this event
             * */
            var isRightMB;
            if ('which' in evt) {
                isRightMB = evt.which === 3;
            }
            else if ('button' in evt) {
                isRightMB = evt.button === 2;
            }
            if (isRightMB) {
                setTimeout(_this.reset);
                return;
            }
            var elem = _this.scrollBlock;
            var startPoint = evt.touches ? evt.touches[0].pageY : evt.pageY;
            var scrollTopOffset = _this.isVirtualized ? (_this.props.scrollTo || 0) : elem.scrollTop;
            _this.blockSelection(false);
            _this.scrollRun = function (e) {
                e.stopPropagation();
                e.preventDefault();
                var _a = _this.getParams(), holderHeight = _a.holderHeight, wrapperHeight = _a.wrapperHeight;
                var diff = holderHeight / wrapperHeight;
                var pageY = e.touches ? e.touches[0].pageY : e.pageY;
                if (_this.isVirtualized) {
                    var scrollTop = ((pageY - startPoint) * diff) + scrollTopOffset;
                    scrollTop = holderHeight - wrapperHeight <= scrollTop ? holderHeight - wrapperHeight : scrollTop;
                    if (is_1.isFunction(_this.props.scrollSync)) {
                        _this.props.scrollSync(scrollTop);
                    }
                }
                else {
                    scrollTo_1.scrollTo(elem, ((pageY - startPoint) * diff) + scrollTopOffset);
                }
            };
            _this.endScroll = function () {
                _this.reset();
            };
            events_1.on(document, ['mouseup', 'touchend'], _this.endScroll);
            events_1.on(document, ['mousemove', 'touchmove'], _this.scrollRun);
        };
        _this.reset = function () {
            _this.removeListeners();
            _this.blockSelection(true);
        };
        _this.restScrollAfterResize = function () {
            _this.nextWrapperHeight = 0;
            _this.nextHolderHeight = 0;
        };
        _this.jump = function (e) {
            var y = e.touches ? e.touches[0].pageY : e.pageY;
            var scrollBar = _this.scrollBarRef.current;
            var scrollPosition = _this.scrollBlock.scrollTop;
            var wrapperHeight = _this.getParams().wrapperHeight;
            var topOffset = _this.scrollBlock.getBoundingClientRect().top;
            if (_this.isVirtualized) {
                scrollPosition = _this.props.scrollTo || 0;
                scrollBar = {
                    offsetTop: _this.state.virtualState.top,
                    offsetHeight: _this.state.virtualState.height
                };
            }
            if (y < (topOffset + scrollBar.offsetTop) ||
                y > (topOffset + scrollBar.offsetTop + scrollBar.offsetHeight)) {
                var offset = topOffset + scrollBar.offsetTop <= y ? 1 : -1;
                var scrollY_1 = (scrollPosition + (wrapperHeight * offset));
                if (_this.isVirtualized) {
                    if (is_1.isFunction(_this.props.scrollSync)) {
                        _this.props.scrollSync(scrollY_1);
                    }
                }
                else {
                    scrollTo_1.scrollTo(_this.scrollBlock, scrollY_1);
                }
            }
        };
        _this.reinit = function () {
            var _a = _this.getParams(), wrapperHeight = _a.wrapperHeight, holderHeight = _a.holderHeight;
            if ((wrapperHeight !== _this.nextWrapperHeight) ||
                (holderHeight !== _this.nextHolderHeight)) {
                if (_this.isVirtualized) {
                    var scrollPosition = _this.props.scrollTo || 0;
                    var virtualState = _this.getScrollBarStyles(scrollPosition);
                    _this.setState({
                        virtualState: virtualState,
                        scrollAreaShow: holderHeight > wrapperHeight
                    });
                }
                else {
                    _this.setState({
                        scrollAreaShow: holderHeight > wrapperHeight
                    });
                }
            }
            _this.nextWrapperHeight = wrapperHeight;
            _this.nextHolderHeight = holderHeight;
        };
        _this.scroll = function () {
            _this.setState({
                scrollTop: _this.scrollBlock.scrollTop
            });
        };
        ['scroll-area', 'scroll-area-holder', 'scrollBar', 'customScroll', 'customScrollHolder', 'customScrollFrame'].forEach(function (r) {
            _this[r + "Ref"] = react_1.createRef();
        });
        var scrollWidth = getDefaultScrollWidth();
        _this.isVirtualized = is_1.isObject(props.virtualized);
        if (isZero) {
            scrollWidth = defaultScrollWidth;
        }
        var className = is_1.isDefined(props.className) ? props.className : 'react-customscroll';
        /**
         * Reinitialize scroll bar every 500 ms
         * */
        _this.interval = setInterval(_this.reinit, REINIT_MS);
        _this.state = {
            scrollTop: 0,
            width: "calc(100% + " + scrollWidth + "px)",
            selection: true,
            scrollAreaShow: false,
            animate: props.animate || true,
            classes: {
                base: className,
                holder: className + "-holder",
                frame: className + "-frame",
                area: className + "-scrollbar-area",
                'area-holder': className + "-scrollbar-holder",
                'scroll-bar': className + "-scrollbar",
            },
            virtualState: _this.isVirtualized ? _this.getScrollBarStyles(props.scrollTo || 0) : null,
            styles: {
                scrollArea: {},
                scrollAreaFrame: {},
                scrollBar: {},
                ctmScroll: {},
                ctmScrollActive: {},
                ctmScrollFrame: {},
                noselect: {},
                ctmScrollHolder: {}
            }
        };
        if (is_1.isClient() && !document.getElementById(_this.scrollID)) {
            generateStyle_1.generateStyle("#" + _this.scrollID + "::-webkit-scrollbar { opacity: 0 }\n#" + _this.scrollID + "::-webkit-scrollbar-track-piece { background-color: transparent }", _this.scrollID);
        }
        return _this;
    }
    CustomScroll.prototype.componentDidMount = function () {
        /**
         * If mouse cursor gone outside window
         * Will trigger event 'mouseWithoutWindow'
         * And all listeners will remove
         * Content in scroll block will be selectable
         * */
        events_1.on(document, ['mouseWithoutWindow'], this.reset);
        events_1.on(window, ['resize'], this.restScrollAfterResize);
        this.scrollBlock = this.customScrollHolderRef.current;
        this.customScroll = this.customScrollRef.current;
        this.customScrollHolder = this.customScrollFrameRef.current;
        this.applyStyles();
    };
    CustomScroll.prototype.componentDidUpdate = function (prevProps) {
        var _this = this;
        var offsetY = this.props.scrollTo;
        // eslint-disable-next-line sonarjs/no-collapsible-if,no-restricted-globals
        if (is_1.isDefined(offsetY) && !isNaN(offsetY)) {
            if (prevProps.scrollTo !== offsetY) {
                if (this.isVirtualized) {
                    offsetY = offsetY || 0;
                    setTimeout(function () {
                        _this.setState({
                            virtualState: _this.getScrollBarStyles(offsetY)
                        });
                    });
                }
                else {
                    scrollTo_1.scrollTo(this.scrollBlock, offsetY, this.state.animate);
                }
            }
        }
    };
    CustomScroll.prototype.componentWillUnmount = function () {
        if (is_1.isClient()) {
            var el = document.getElementById(this.scrollID);
            if (el) {
                el.parentNode.removeChild(el);
            }
        }
        clearInterval(this.interval);
        this.removeListeners();
    };
    CustomScroll.prototype.getParams = function () {
        var wrapperHeight = 0;
        var holderHeight = 0;
        var percentDiff = 0;
        var height = 0;
        if (!is_1.isClient()) {
            return {
                wrapperHeight: wrapperHeight,
                holderHeight: holderHeight,
                percentDiff: percentDiff,
                height: height
            };
        }
        var scrollArea = this['scroll-areaRef'].current;
        var paddings = window && scrollArea ?
            parseFloat(window.getComputedStyle(scrollArea, null)
                .getPropertyValue('padding-top')) +
                parseFloat(window.getComputedStyle(scrollArea, null)
                    .getPropertyValue('padding-bottom')) :
            0;
        if (this.isVirtualized) {
            wrapperHeight = this.props.virtualized.height || 0;
            holderHeight = this.props.virtualized.scrollHeight || 0;
        }
        else {
            wrapperHeight = this.customScroll && this.customScroll.offsetHeight;
            holderHeight = this.customScroll && this.customScrollHolder.offsetHeight;
        }
        if (holderHeight === 0) {
            height = 0;
            percentDiff = 0;
        }
        else {
            percentDiff = (wrapperHeight - paddings) / holderHeight;
            height = wrapperHeight * percentDiff;
        }
        return {
            wrapperHeight: Math.ceil(wrapperHeight),
            holderHeight: holderHeight,
            percentDiff: percentDiff,
            height: height
        };
    };
    CustomScroll.prototype.getScrollBarStyles = function (offsetY) {
        if (offsetY === void 0) { offsetY = 0; }
        var _a = this.getParams(), holderHeight = _a.holderHeight, percentDiff = _a.percentDiff, height = _a.height;
        if (holderHeight === 0 && percentDiff === 0 && height === 0) {
            return {
                top: 0,
                height: 0
            };
        }
        var scrollTop = this.isVirtualized ? offsetY : this.state.scrollTop || this.scrollBlock.scrollTop;
        var newPercentDiff = height < minHeightScrollBar ?
            percentDiff - ((minHeightScrollBar - height) / holderHeight) :
            percentDiff;
        var scrollBarHeight = height < minHeightScrollBar ? minHeightScrollBar : height;
        return {
            top: scrollTop * newPercentDiff,
            height: scrollBarHeight
        };
    };
    CustomScroll.prototype.setY = function (value) {
        scrollTo_1.scrollTo(this.scrollBlock, value, this.state.animate);
    };
    CustomScroll.prototype.removeListeners = function () {
        events_1.off(document, ['mouseWithoutWindow'], this.reset);
        events_1.off(window, ['resize'], this.restScrollAfterResize);
        events_1.off(document, ['mouseup', 'touchend'], this.endScroll);
        events_1.off(document, ['mousemove', 'touchmove'], this.scrollRun);
    };
    CustomScroll.prototype.blockSelection = function (state) {
        if (!state) {
            clearSelection_1.clearSelection();
        }
        this.setState({ selection: !!state });
    };
    CustomScroll.prototype.applyStyles = function () {
        var _this = this;
        var scrollWidth = getDefaultScrollWidth();
        this.setState(function (state) { return (Object.assign(state, {
            styles: styles_1.stylesFactory({
                virtualized: _this.isVirtualized,
                isZero: isZero,
                originalScrollWidth: scrollWidth,
                scrollWidth: is_1.isDefined(_this.props.scrollWidth) ? _this.props.scrollWidth : '6px',
                scrollAreaColor: is_1.isDefined(_this.props.scrollAreaColor) ? _this.props.scrollAreaColor : '#494949',
                scrollBarRadius: is_1.isDefined(_this.props.scrollBarRadius) ? _this.props.scrollBarRadius : '6px',
                scrollBarColor: is_1.isDefined(_this.props.scrollBarColor) ? _this.props.scrollBarColor : '#aeaeae'
            }, !!_this.props.rtl)
        })); });
    };
    CustomScroll.prototype.render = function () {
        var ctmScroll = !this.state.selection ?
            Object.assign({}, this.state.styles.ctmScroll, this.state.styles.noselect) :
            this.state.styles.ctmScroll;
        var ctmScrollFrame = this.state.scrollAreaShow ?
            Object.assign({}, this.state.styles.ctmScrollFrame, this.state.styles.ctmScrollActive) :
            this.state.styles.ctmScrollFrame;
        return (react_1.default.createElement("div", { ref: this.customScrollRef, style: Object.assign({ boxSizing: 'border-box' }, ctmScroll), className: this.state.classes.base, suppressHydrationWarning: true },
            react_1.default.createElement("div", { ref: this.customScrollHolderRef, style: Object.assign({ boxSizing: 'border-box' }, { width: this.state.width }, this.state.styles.ctmScrollHolder), onScroll: this.scroll, className: this.state.classes.holder, id: this.scrollID, suppressHydrationWarning: true },
                react_1.default.createElement("div", { ref: this.customScrollFrameRef, style: Object.assign({ boxSizing: 'border-box' }, ctmScrollFrame, isZero ?
                        { width: '100%' } : {}), className: this.state.classes.frame, suppressHydrationWarning: true }, is_1.isFunction(this.props.children) ?
                    this.props.children(this.scrollBlock && this.scrollBlock.scrollTop ?
                        this.scrollBlock.scrollTop :
                        0) :
                    this.props.children),
                this.state.scrollAreaShow ? (react_1.default.createElement("div", { ref: this['scroll-areaRef'], style: this.state.styles.scrollArea, onClick: this.jump, className: this.state.classes.area },
                    react_1.default.createElement("div", { ref: this['scroll-area-holderRef'], style: this.state.styles.scrollAreaFrame, className: this.state.classes['area-holder'] },
                        react_1.default.createElement("div", { ref: this.scrollBarRef, style: Object.assign({}, this.state.styles.scrollBar, this.isVirtualized ?
                                this.state.virtualState :
                                this.getScrollBarStyles()), onMouseDown: this.onClick, onTouchStart: this.onClick, className: this.state.classes['scroll-bar'] })))) : null)));
    };
    return CustomScroll;
}(react_1.Component));
exports.CustomScroll = CustomScroll;
