"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mouseWithoutWindow = void 0;
var is_1 = require("../utils/is");
var fire = function () {
    var event = document.createEvent('Event');
    event.initEvent('mouseWithoutWindow', true, true);
    document.dispatchEvent(event);
};
var MouseWithoutWindow = (function () {
    var instance;
    var createInstance = function () {
        document.addEventListener('mouseup', function (e) {
            var w = window;
            var d = document;
            var el = d.documentElement;
            var body = d.getElementsByTagName('body')[0];
            var width = w.innerWidth || el.clientWidth || body.clientWidth;
            var height = w.innerHeight || el.clientHeight || body.clientHeight;
            if ((e.clientX >= width ||
                e.clientX < 0) ||
                (e.clientY >= height ||
                    e.clientY < 0)) {
                fire();
            }
        });
        window.addEventListener('blur', function () {
            fire();
        });
        return true;
    };
    return {
        getInstance: function () {
            if (instance) {
                return instance;
            }
            instance = createInstance();
        }
    };
})();
exports.mouseWithoutWindow = function () {
    if (is_1.isClient()) {
        MouseWithoutWindow.getInstance();
    }
};
