"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scrollTo = void 0;
var _scrollTo = function (element, to, duration) {
    if (duration <= 0) {
        return;
    }
    var difference = to - element.scrollTop;
    var perTick = (difference / duration) * 10;
    setTimeout(function () {
        element.scrollTop += perTick;
        if (element.scrollTop === to) {
            return;
        }
        _scrollTo(element, to, duration - 10);
    }, 10);
};
exports.scrollTo = function (domEl, offsetY, animate) {
    if (animate) {
        _scrollTo(domEl, offsetY, 500);
    }
    else {
        domEl.scrollTop = offsetY;
    }
};
